#import <CoreFoundation/CoreFoundation.h>
#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#include <stdio.h>
#include <string.h>
#include <dlfcn.h>
#include <stdio.h>
#include <unistd.h>

//@class UIApplication;
@class UISlider;
@class UIImage;
@class UIImageView;
@class UIButton;
@class UILabel;
@class UIColor;

typedef NSUInteger UIControlState;
#import <UIKit/UISlider.h>

#define UIControlStateNormal 0
#define UIControlEventTouchUpInside (1 << 6)
#define UIControlEventValueChanged  (1 << 12)

@interface BrightnessView : UIView
{
	UISlider*			Slider;
	BOOL				ValueChanged;
	float				CurrentBacklight;
}

- (BrightnessView*) initWindow;
- (void) transitionOut;
- (void) transitionIn;
- (void) CloseButtonPressed; 
- (void) endTimer:(NSTimer *)timer;
- (void) sliderDidChange;
- (UIWindow*) getAppWindow;
@end

@implementation BrightnessView

//************************************************************************************************************
// initWindow - Initializes the brightness view window.
//************************************************************************************************************
- (BrightnessView*) initWindow
{
	ValueChanged = NO;
	self = [super initWithFrame:CGRectMake(-274.0f, 40.0f, 274.0f, 71.0f)];
	NSString* CurrentTheme;
	UIWindow* Window = [self getAppWindow];
	if([Window respondsToSelector:@selector(getCurrentTheme)])
	{
		CurrentTheme = [NSString stringWithString:[Window getCurrentTheme]];
	}
	else
	{
		CurrentTheme = [NSString stringWithString:@"Default"];
	}
	
	// Setup the background image.
	UIImageView* Image = [[UIImageView alloc] initWithFrame: CGRectMake(0.0f, 0.0f, 274.0f, 71.0f)];
	Image.image = [UIImage imageWithContentsOfFile:[NSString stringWithFormat:@"/var/mobile/Library/SBSettings/Themes/%@/SliderFrame.png", CurrentTheme]];
	[self addSubview: Image];
	[Image release];
	
	// Setup the label
	UILabel* Label = [[UILabel alloc] initWithFrame:CGRectMake(100.0f, 15.0f, 100.0f, 20.0f)]; 
	[Label setText:@"Brightness"];
	[Label setTextColor:[UIColor whiteColor]];
	[Label setBackgroundColor: [UIColor clearColor]];
	[self addSubview: Label];
	[Label release];
	
	// Setup the slider
	Slider = [[UISlider alloc] initWithFrame: CGRectMake(22.0f, 22.0f, 228.0f, 52.0f)];
	[Slider setMinimumValue: 0.01];
	[Slider addTarget:self action:@selector(sliderDidChange) forControlEvents:UIControlEventValueChanged];
	float CurrentBacklight2 = [[[NSMutableDictionary dictionaryWithContentsOfFile:@"/var/mobile/Library/Preferences/com.apple.springboard.plist"] objectForKey:@"SBBacklightLevel2"] floatValue];

	float CurrentBacklight1 = [[[NSMutableDictionary dictionaryWithContentsOfFile:@"/var/mobile/Library/Preferences/com.apple.springboard.plist"] objectForKey:@"SBBacklightLevel"] floatValue];

	float CurrentBacklight = 0.50f;
	if(CurrentBacklight2 > 0) CurrentBacklight = CurrentBacklight2;
	else if(CurrentBacklight1 > 0) CurrentBacklight = CurrentBacklight1;
	
	[Slider setValue: CurrentBacklight];
	[self addSubview: Slider];
	
	// Setup the close button
	UIButton* CloseButtonBigger = [[UIButton alloc] initWithFrame:CGRectMake(234.0f, 0.0f, 40.0f, 40.0f)];
	[CloseButtonBigger addTarget:self action:@selector(CloseButtonPressed) forControlEvents:UIControlEventTouchUpInside];
	[self addSubview: CloseButtonBigger];
	[CloseButtonBigger release];

	UIButton* CloseButton = [[UIButton alloc] initWithFrame:CGRectMake(244.0f, 5.0f, 25.0f, 25.0f)];
	[CloseButton setShowsTouchWhenHighlighted: YES];
	[CloseButton setBackgroundImage:[UIImage imageWithContentsOfFile:[NSString stringWithFormat:@"/var/mobile/Library/SBSettings/Themes/%@/Close.png", CurrentTheme]] forState:UIControlStateNormal];
	[CloseButton addTarget:self action:@selector(CloseButtonPressed) forControlEvents:UIControlEventTouchUpInside];
	[self addSubview: CloseButton];
	[CloseButton release];
	
	return self;
}

//************************************************************************************************************
// scrollViewDidScroll - The scroll control delegate - this is where the brightness is actually changed..
//************************************************************************************************************
- (void)sliderDidChange
{
	CurrentBacklight = (float)([Slider value]);
	UIApplication* TheApp = [UIApplication sharedApplication];
	[TheApp setBacklightLevel:CurrentBacklight];
	ValueChanged = YES;
	//notify_post("com.apple.springboard-screenPrefsChanged");
}

//************************************************************************************************************
// CloseButtonPressed: When the close button pressed. Closes up the window.
//************************************************************************************************************
- (void) CloseButtonPressed 
{
	NSLog(@"Value changed = %D\n", ValueChanged);
	if(ValueChanged == YES)
	{
		NSMutableDictionary* Prefs = [NSMutableDictionary dictionaryWithContentsOfFile:@"/var/mobile/Library/Preferences/com.apple.springboard.plist"];

		if(Prefs != nil)
		{
			NSLog(@"Prefs != nil\n");
			float CurrentBacklight1 = [[Prefs objectForKey:@"SBBacklightLevel"] floatValue];
			float CurrentBacklight2 = [[Prefs objectForKey:@"SBBacklightLevel2"] floatValue];
			NSNumber* Number = [NSNumber numberWithFloat:CurrentBacklight];
			
			if(CurrentBacklight2 > 0)
			{
				NSLog(@"CurrentBacklight2 = %f\n", CurrentBacklight2);
				[Prefs setObject:Number forKey:@"SBBacklightLevel2"];
			}
			if(CurrentBacklight1 > 0)
			{
				NSLog(@"CurrentBacklight1 = %f\n", CurrentBacklight1);
				[Prefs setObject:Number forKey:@"SBBacklightLevel"];
			}
			[Prefs writeToFile:@"/var/mobile/Library/Preferences/com.apple.springboard.plist" atomically:YES];
		}
	}
	[self transitionOut];
}

//************************************************************************************************************
// transitionOut - transitions the window view out.
//************************************************************************************************************
- (void) transitionOut
{
	[UIView beginAnimations:nil context:NULL];
	[UIView setAnimationDuration:0.5];
	[[[UIApplication sharedApplication] keyWindow] addSubview: self];
	CGAffineTransform transformView	= CGAffineTransformMakeTranslation(-297.0f, 0.0f);
	[self setTransform: transformView];
	[UIView commitAnimations];

	[NSTimer scheduledTimerWithTimeInterval:0.9 target:self selector:@selector(endTimer:) userInfo:nil repeats:NO];
}

//************************************************************************************************************
// endTimer: Timer callback to remove the rest of the controls after animation completes.
//************************************************************************************************************
- (void) endTimer:(NSTimer *)timer 
{
	[Slider release];
	[self removeFromSuperview];
}

//************************************************************************************************************
// getAppWindow - attempts to retrieve the app window.
//************************************************************************************************************
- (UIWindow*) getAppWindow
{
	UIWindow* TheWindow = nil;
	UIApplication* App = [UIApplication sharedApplication];
	NSArray* windows = [App windows];
	int i;
	for(i = 0; i < [windows count]; i++)
	{
		TheWindow = [windows objectAtIndex:i];
		if([TheWindow respondsToSelector:@selector(getCurrentTheme)])
		{
			break;
		}
	}
	
	if(i == [windows count])
	{
		NSLog(@"Couldn't find the app window, defaulting to keyWindow\n");
		TheWindow = [App keyWindow];
	}
	
	return TheWindow;
}

//************************************************************************************************************
// transitionIn - animates the view in place.
//************************************************************************************************************
- (void) transitionIn
{
	UIWindow* TheWindow = [self getAppWindow];
	
	[TheWindow addSubview: self];

	[UIView beginAnimations:nil context:NULL];
	[UIView setAnimationDuration:0.5];
	CGAffineTransform transformView	= CGAffineTransformMakeTranslation(297.0f, 0.0f);
	[self setTransform: transformView];
	[UIView commitAnimations];
}

@end

BOOL isCapable()
{
	return YES;
}

BOOL isEnabled()
{
	return YES;
}


void setState(BOOL Enable)
{
	BrightnessView* Brightness = [[BrightnessView alloc] initWindow];
	[Brightness transitionIn];
	[Brightness release];
}

float getDelayTime()
{
	return 0.0f;
}


